## incus 6.0.4

=== Makefile ===
GO ?= go
DOMAIN=incus
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot
VERSION=$(or ${CUSTOM_VERSION},$(shell grep "var Version" internal/version/flex.go | cut -d'"' -f2))
ARCHIVE=incus-$(VERSION).tar
HASH := \#
TAG_SQLITE3=$(shell printf "$(HASH)include <cowsql.h>\nvoid main(){cowsql_node_id n = 1;}" | $(CC) ${CGO_CFLAGS} -o /dev/null -xc - >/dev/null 2>&1 && echo "libsqlite3")
GOPATH ?= $(shell $(GO) env GOPATH)
CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)
SPHINXENV=doc/.sphinx/venv/bin/activate
SPHINXPIPPATH=doc/.sphinx/venv/bin/pip
OVN_MINVER=22.03.0
OVS_MINVER=2.15.0

ifneq "$(wildcard vendor)" ""
	RAFT_PATH=$(CURDIR)/vendor/raft
	COWSQL_PATH=$(CURDIR)/vendor/cowsql
else
	RAFT_PATH=$(GOPATH)/deps/raft
	COWSQL_PATH=$(GOPATH)/deps/cowsql
endif

	# raft
.PHONY: default
default: build

.PHONY: build
build:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing cowsql, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: client
client:
	$(GO) install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./cmd/incus
	@echo "Incus client built successfully"

.PHONY: incus-agent
incus-agent:
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus agent built successfully"

.PHONY: incus-migrate
incus-migrate:
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	@echo "Incus migration tool built successfully"

.PHONY: deps
deps:
	@if [ ! -e "$(RAFT_PATH)" ]; then \
		git clone --depth=1 "https://github.com/cowsql/raft" "$(RAFT_PATH)"; \
	elif [ -e "$(RAFT_PATH)/.git" ]; then \
		cd "$(RAFT_PATH)"; git pull; \
	fi

	cd "$(RAFT_PATH)" && \
		autoreconf -i && \
		./configure && \
		make

	# cowsql
	@if [ ! -e "$(COWSQL_PATH)" ]; then \
		git clone --depth=1 "https://github.com/cowsql/cowsql" "$(COWSQL_PATH)"; \
	elif [ -e "$(COWSQL_PATH)/.git" ]; then \
		cd "$(COWSQL_PATH)"; git pull; \
	fi

	cd "$(COWSQL_PATH)" && \
		autoreconf -i && \
		PKG_CONFIG_PATH="$(RAFT_PATH)" ./configure && \
		make CFLAGS="-I$(RAFT_PATH)/include/" LDFLAGS="-L$(RAFT_PATH)/.libs/"

	# environment
	@echo ""
	@echo "Please set the following in your environment (possibly ~/.bashrc)"
	@echo "export CGO_CFLAGS=\"-I$(RAFT_PATH)/include/ -I$(COWSQL_PATH)/include/\""
	@echo "export CGO_LDFLAGS=\"-L$(RAFT_PATH)/.libs -L$(COWSQL_PATH)/.libs/\""
	@echo "export LD_LIBRARY_PATH=\"$(RAFT_PATH)/.libs/:$(COWSQL_PATH)/.libs/\""
	@echo "export CGO_LDFLAGS_ALLOW=\"(-Wl,-wrap,pthread_create)|(-Wl,-z,now)\""

.PHONY: update-gomod
update-gomod:
ifneq "$(INCUS_OFFLINE)" ""
	@echo "The update-gomod target cannot be run in offline mode."
	exit 1
endif
	$(GO) get -t -v -u ./...
	$(GO) mod tidy --go=1.23.7
	$(GO) get toolchain@none

	@echo "Dependencies updated"

.PHONY: update-ovsdb
update-ovsdb:
	go install github.com/ovn-org/libovsdb/cmd/modelgen@main

	rm -Rf internal/server/network/ovs/schema
	mkdir internal/server/network/ovs/schema
	curl -s https://raw.githubusercontent.com/openvswitch/ovs/v$(OVS_MINVER)/vswitchd/vswitch.ovsschema -o internal/server/network/ovs/schema/ovs.json
	modelgen -o internal/server/network/ovs/schema/ovs internal/server/network/ovs/schema/ovs.json
	rm internal/server/network/ovs/schema/*.json

	rm -Rf internal/server/network/ovn/schema
	mkdir internal/server/network/ovn/schema
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-nb.ovsschema -o internal/server/network/ovn/schema/ovn-nb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-sb.ovsschema -o internal/server/network/ovn/schema/ovn-sb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-ic-nb.ovsschema -o internal/server/network/ovn/schema/ovn-ic-nb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-ic-sb.ovsschema -o internal/server/network/ovn/schema/ovn-ic-sb.json
	modelgen -o internal/server/network/ovn/schema/ovn-nb internal/server/network/ovn/schema/ovn-nb.json
	modelgen -o internal/server/network/ovn/schema/ovn-sb internal/server/network/ovn/schema/ovn-sb.json
	modelgen -o internal/server/network/ovn/schema/ovn-ic-nb internal/server/network/ovn/schema/ovn-ic-nb.json
	modelgen -o internal/server/network/ovn/schema/ovn-ic-sb internal/server/network/ovn/schema/ovn-ic-sb.json
	rm internal/server/network/ovn/schema/*.json

.PHONY: update-protobuf
update-protobuf:
	protoc --go_out=. ./internal/migration/migrate.proto

.PHONY: update-schema
update-schema:
	cd cmd/generate-database && $(GO) build -o $(GOPATH)/bin/generate-database -tags "$(TAG_SQLITE3)" $(DEBUG) && cd -
	$(GO) generate ./...
	gofumpt -w ./internal/server/db/
	goimports -w ./internal/server/db/
	@echo "Code generation completed"

.PHONY: update-api
update-api:
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/go-swagger/go-swagger/cmd/swagger@latest)
endif
	swagger generate spec -o doc/rest-api.yaml -w ./cmd/incusd -m

.PHONY: update-metadata
update-metadata: build
	@echo "Generating golang documentation metadata"
	cd cmd/generate-config && CGO_ENABLED=0 $(GO) build -o $(GOPATH)/bin/generate-config
	$(GOPATH)/bin/generate-config . --json ./internal/server/metadata/configuration.json --txt ./doc/config_options.txt

.PHONY: doc-setup
doc-setup: client
	@echo "Setting up documentation build environment"
	python3 -m venv doc/.sphinx/venv
	. $(SPHINXENV) ; pip install --require-virtualenv --upgrade -r doc/.sphinx/requirements.txt --log doc/.sphinx/venv/pip_install.log
	@test ! -f doc/.sphinx/venv/pip_list.txt || \
        mv doc/.sphinx/venv/pip_list.txt doc/.sphinx/venv/pip_list.txt.bak
	$(SPHINXPIPPATH) list --local --format=freeze > doc/.sphinx/venv/pip_list.txt
	find doc/reference/manpages/ -name "*.md" -type f -delete
	rm -Rf doc/html
	rm -Rf doc/.sphinx/.doctrees

.PHONY: doc
doc: doc-setup doc-incremental

.PHONY: doc-incremental
doc-incremental:
	@echo "Build the documentation"
	. $(SPHINXENV) ; sphinx-build -c doc/ -b dirhtml doc/ doc/html/ -d doc/.sphinx/.doctrees -w doc/.sphinx/warnings.txt

.PHONY: doc-serve
doc-serve:
	cd doc/html; python3 -m http.server 8001

.PHONY: doc-spellcheck
doc-spellcheck: doc
	. $(SPHINXENV) ; python3 -m pyspelling -c doc/.sphinx/spellingcheck.yaml

.PHONY: doc-linkcheck
doc-linkcheck: doc-setup
	. $(SPHINXENV) ; LOCAL_SPHINX_BUILD=True sphinx-build -c doc/ -b linkcheck doc/ doc/html/ -d doc/.sphinx/.doctrees

.PHONY: doc-lint
doc-lint:
	doc/.sphinx/.markdownlint/doc-lint.sh

.PHONY: woke-install
woke-install:
	@type woke >/dev/null 2>&1 || \
        { echo "Installing \"woke\" snap... \n"; sudo snap install woke; }

.PHONY: doc-woke
doc-woke: woke-install
	woke *.md **/*.md -c https://github.com/canonical/Inclusive-naming/raw/main/config.yml

.PHONY: debug
debug:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -v -tags "$(TAG_SQLITE3) logdebug" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags "netgo,logdebug" ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags "agent,netgo,logdebug" ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: nocache
nocache:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -a -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -a -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -a -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

race:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -race -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: check
check: default
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/rogpeppe/godeps@latest)
	(cd / ; $(GO) install -v -x github.com/tsenart/deadcode@latest)
	(cd / ; $(GO) install -v -x golang.org/x/lint/golint@latest)
endif
	CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) test -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	cd test && ./main.sh

.PHONY: dist
dist: doc
	# Cleanup
	rm -Rf $(ARCHIVE).xz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=incus-$(VERSION)/ HEAD | tar -x -C $(TMP)
	git show-ref HEAD | cut -d' ' -f1 > $(TMP)/incus-$(VERSION)/.gitref

	# Download dependencies
	(cd $(TMP)/incus-$(VERSION) ; $(GO) mod vendor)

	# Download the cowsql libraries
	git clone --depth=1 https://github.com/cowsql/cowsql $(TMP)/incus-$(VERSION)/vendor/cowsql
	(cd $(TMP)/incus-$(VERSION)/vendor/cowsql ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	git clone --depth=1 https://github.com/cowsql/raft $(TMP)/incus-$(VERSION)/vendor/raft
	(cd $(TMP)/incus-$(VERSION)/vendor/raft ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	# Copy doc output
	cp -r doc/html $(TMP)/incus-$(VERSION)/doc/html/

	# Assemble tarball
	tar --exclude-vcs -C $(TMP) -Jcf $(ARCHIVE).xz incus-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n
i18n: update-pot update-po

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

.PHONY: update-po
update-po:
	set -eu; \
	for lang in $(LINGUAS); do\
	    msgmerge --backup=none -U $$lang.po po/$(DOMAIN).pot; \
	done

.PHONY: update-pot
update-pot:
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/snapcore/snapd/i18n/xgettext-go@2.57.1)
endif
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG cmd/incus/*.go shared/cliconfig/*.go

.PHONY: build-mo
build-mo: $(MOFILES)

.PHONY: static-analysis
static-analysis:
ifeq ($(shell command -v go-licenses),)
	(cd / ; $(GO) install -v -x github.com/google/go-licenses@latest)
endif
ifeq ($(shell command -v golangci-lint),)
	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $$($(GO) env GOPATH)/bin
endif
ifeq ($(shell command -v shellcheck),)
	echo "Please install shellcheck"
	exit 1
else
endif
ifeq ($(shell command -v flake8),)
	echo "Please install flake8"
	exit 1
endif
ifeq ($(shell command -v codespell),)
	echo "Please install codespell"
	exit 1
endif
	flake8 test/deps/import-busybox
	shellcheck --shell sh test/*.sh test/includes/*.sh test/suites/*.sh test/backends/*.sh test/lint/*.sh
	shellcheck test/extras/*.sh
	run-parts $(shell run-parts -V >/dev/null 2>&1 && echo -n "--verbose --exit-on-error --regex '.sh'") test/lint

.PHONY: staticcheck
staticcheck:
ifeq ($(shell command -v staticcheck),)
	(cd / ; $(GO) install -v -x honnef.co/go/tools/cmd/staticcheck@latest)
endif
	# To get advance notice of deprecated function usage, consider running:
	#   sed -i 's/^go 1\.[0-9]\+$/go 1.18/' go.mod
	# before 'make staticcheck'.

	# Run staticcheck against all the dirs containing Go files.
	staticcheck $$(git ls-files *.go | sed 's|^|./|; s|/[^/]\+\.go$$||' | sort -u)

.PHONY: tags
tags: */*.go
ifeq ($(shell command -v gotags),)
	(cd / ; $(GO) install -v -x github.com/jstemmer/gotags@latest)
endif
	find . -type f -name '*.go' | gotags -L - -f tags

# OpenFGA Syntax Transformer: https://github.com/openfga/syntax-transformer
.PHONY: update-openfga
update-openfga:
ifeq ($(shell command -v fga),)
	(cd / ; $(GO) install -v -x github.com/openfga/cli/cmd/fga@latest)
endif

=== doc/.sphinx/requirements.txt ===
furo
gitpython
linkify-it-py
lxd-sphinx-extensions
myst-parser
pyspelling
sphinx
sphinx-autobuild
sphinx-copybutton
sphinx-design
sphinx-notfound-page
sphinx-remove-toctrees
sphinx-reredirects
sphinx-tabs
sphinxcontrib-jquery
sphinxext-opengraph

=== debian/changelog ===
incus (6.0.4-2+deb13u1) trixie-security; urgency=high

  * Backport fixes for the following security issues:
    - CVE-2025-54293 / GHSA-472f-vmf2-pr3h
    - CVE-2025-54287 / GHSA-w2hg-2v4p-vmh6
    - CVE-2025-54288 / GHSA-7232-97c6-j525
    - CVE-2025-54286 / GHSA-p8hw-rfjg-689h
    - CVE-2025-54290 / GHSA-p3x5-mvmp-5f35
    - CVE-2025-54291 / GHSA-xch9-h8qw-85c7
    - CVE-2025-54289 / GHSA-3g72-chj4-2228

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 02 Oct 2025 15:51:07 +0000

incus (6.0.4-2) unstable; urgency=medium

  * Fix inadvertent policy violation where build created files in HOME
    (Closes: #1103554)
  * Cherry-pick upstream fixes:
    - Cleanup old qemu sockets
    - Retry agent mounts
    - USB hotplugging
  * d/control:
    - Add back Build-Using stanzas
    - Add squashfs-tools-ng to incus-base Required packages
    - Have incus-client Suggest "spice-client-gtk | virt-viewer"
  * Update systemd service to wait long enough for Incus to correctly shutdown
  * Update systemd and sysv init scripts to use `incusd waitready`

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 27 Apr 2025 14:45:33 +0000

incus (6.0.4-1) unstable; urgency=medium

  * New upstream release
    - Rebase patches and drop upstream cherry-picked commits
  * d/control:
    - Update Build-Depends and Depends
    - Add lego to list of Suggested packages for incus-base

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 04 Apr 2025 02:43:07 +0000

incus (6.0.3-5) unstable; urgency=medium

  [ Martin Steigerwald ]
  * Runit support for Incus (Closes: #1084990)

  [ Mathias Gibbens ]
  * d/control:
    - Apply hack for /usr-move (Closes: #1099444; DEP17 P1 M7)
    - Update minimum required version of lxcfs to ensure its runit scripts
      will be available
    - Set minimum version of apparmor
    - Replace Built-Using with Static-Built-Using
  * Add apparmor 4.x userns patch
  * Cherry-pick upstream commit for selecting SecureBoot capable OVMF
  * Cherry-pick upstream fix for qemu 10
  * Update d/README.Debian to reflect addition of runit scripts
  * Fix lintian warning old-fsf-address-in-copyright-file in d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 31 Mar 2025 22:36:28 +0000

=== debian/control ===
Source: incus
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Free Ekanayaka <freee@debian.org>, Mathias Gibbens <gibmat@debian.org>
Section: admin
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 2:1.22~),
               golang-github-armon-go-proxyproto-dev,
               golang-github-cenkalti-backoff-dev,
               golang-github-checkpoint-restore-go-criu-dev (>= 7),
               golang-github-cowsql-go-cowsql-dev,
               golang-github-digitalocean-go-qemu-dev,
               golang-github-digitalocean-go-smbios-dev,
               golang-github-dustinkirkland-golang-petname-dev,
               golang-github-flosch-pongo2.v4-dev,
               golang-github-fvbommel-sortorder-dev,
               golang-github-go-chi-chi-dev,
               golang-github-go-jose-go-jose-dev,
               golang-github-go-logr-logr-dev,
               golang-github-golang-jwt-jwt-v5-dev,
               golang-github-golang-protobuf-1-5-dev,
               golang-github-google-gopacket-dev,
               golang-github-google-uuid-dev,
               golang-github-gorilla-mux-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-gosexy-gettext-dev,
               golang-github-j-keck-arping-dev,
               golang-github-jaypipes-pcidb-dev,
               golang-github-jochenvg-go-udev-dev,
               golang-github-kballard-go-shellquote-dev,
               golang-github-mattn-go-colorable-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-mdlayher-ndp-dev,
               golang-github-mdlayher-netx-dev,
               golang-github-mdlayher-vsock-dev,
               golang-github-miekg-dns-dev,
               golang-github-minio-minio-go-v7-dev,
               golang-github-mitchellh-mapstructure-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-openfga-go-sdk-dev (>= 0.6.0),
               golang-github-osrg-gobgp-dev (>= 3.10.0),
               golang-github-ovn-org-libovsdb-dev,
               golang-github-pierrec-lz4-dev (>= 4.1.18),
               golang-github-pkg-sftp-dev,
               golang-github-pkg-xattr-dev,
               golang-github-rican7-retry-dev,
               golang-github-robfig-cron-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stretchr-testify-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-zitadel-oidc-dev (>= 3.0),
               golang-gocapability-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-exp-dev,
               golang-golang-x-oauth2-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-golang-x-text-dev,
               golang-golang-x-tools-dev,
               golang-google-protobuf-dev,
               golang-gopkg-lxc-go-lxc.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-gopkg-yaml.v2-dev,
               golang-k8s-utils-dev,
               golang-starlark-dev (>= 0.0~git20240725.42030a7),
               help2man,
               libacl1-dev,
               libcap-dev,
               dh-sequence-runit
Build-Conflicts: golang-github-golang-protobuf-1-3-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/incus
Vcs-Git: https://salsa.debian.org/go-team/packages/incus.git
Homepage: https://linuxcontainers.org/incus/
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/lxc/incus

Package: golang-github-lxc-incus-dev
Architecture: all
Multi-Arch: foreign
Section: golang
Depends: golang-github-armon-go-proxyproto-dev,
         golang-github-cenkalti-backoff-dev,
         golang-github-checkpoint-restore-go-criu-dev (>= 7),
         golang-github-cowsql-go-cowsql-dev,
         golang-github-digitalocean-go-qemu-dev,
         golang-github-digitalocean-go-smbios-dev,
         golang-github-dustinkirkland-golang-petname-dev,
         golang-github-flosch-pongo2.v4-dev,
         golang-github-fvbommel-sortorder-dev,
         golang-github-go-chi-chi-dev,
         golang-github-go-jose-go-jose-dev,
         golang-github-go-logr-logr-dev,
         golang-github-golang-jwt-jwt-v5-dev,
         golang-github-golang-protobuf-1-5-dev,
         golang-github-google-gopacket-dev,
         golang-github-google-uuid-dev,
         golang-github-gorilla-mux-dev,
         golang-github-gorilla-websocket-dev,
         golang-github-gosexy-gettext-dev,
         golang-github-j-keck-arping-dev,
         golang-github-jaypipes-pcidb-dev,
         golang-github-jochenvg-go-udev-dev,
         golang-github-kballard-go-shellquote-dev,
         golang-github-mattn-go-colorable-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-mdlayher-ndp-dev,
         golang-github-mdlayher-netx-dev,
         golang-github-mdlayher-vsock-dev,
         golang-github-miekg-dns-dev,
         golang-github-minio-minio-go-v7-dev,
         golang-github-mitchellh-mapstructure-dev,
         golang-github-olekukonko-tablewriter-dev,
         golang-github-openfga-go-sdk-dev (>= 0.6.0),
         golang-github-osrg-gobgp-dev (>= 3.10.0),
         golang-github-ovn-org-libovsdb-dev,
         golang-github-pierrec-lz4-dev (>= 4.1.18),
         golang-github-pkg-sftp-dev,
         golang-github-pkg-xattr-dev,
         golang-github-rican7-retry-dev,
         golang-github-robfig-cron-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-stretchr-testify-dev,
         golang-github-vishvananda-netlink-dev,
         golang-github-zitadel-oidc-dev (>= 3.0),
         golang-gocapability-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-exp-dev,
         golang-golang-x-oauth2-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-term-dev,
         golang-golang-x-text-dev,
         golang-golang-x-tools-dev,
         golang-google-protobuf-dev,
         golang-gopkg-lxc-go-lxc.v2-dev,
         golang-gopkg-tomb.v2-dev,
         golang-gopkg-yaml.v2-dev,
         golang-k8s-utils-dev,
         golang-starlark-dev (>= 0.0~git20240725.42030a7),
         ${misc:Depends}
Description: Powerful system container and virtual machine manager - library
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 This package contains the Incus source code for use in building other
 Debian packages -- normal users should not directly use this package in
 their regular development workflow. Rather, they should use `go get`.

Package: incus
# Technically this package is arch:all, but to use architecture restrictions for
# the qemu-system-* dependencies, we must use a variant of arch:any
Architecture: linux-any
Depends: ${misc:Depends},
         incus-agent (= ${binary:Version}),
         incus-base (= ${binary:Version}),
         qemu-system-arm (>= 1:8.0) [arm64 armel armhf],
         qemu-system-mips (>= 1:8.0) [mips64el],
         qemu-system-ppc (>= 1:8.0) [ppc64el],
         qemu-system-riscv (>= 1:8.0) [riscv64],
         qemu-system-s390x (>= 1:8.0) [s390x],
         qemu-system-x86 (>= 1:8.0) [amd64 i386],
         swtpm,
         virtiofsd [!armel !armhf !i386]
Suggests: gdisk
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Description: Powerful system container and virtual machine manager - daemon
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 It's image based with pre-made images available for a wide number of
 Linux distributions and is built around a very powerful, yet pretty
 simple, REST API.
 .
 This metapackage will install everything needed to run containers and VMs.

Package: incus-base
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         attr,
         ca-certificates,
         liblxc-common,
         lxcfs (>= 6.0.3-2),
         incus-client (= ${binary:Version}),
         iproute2,
         nftables | iptables,
         rsync,
         squashfs-tools,
         squashfs-tools-ng,
         uidmap,
         xz-utils
Recommends: apparmor (>= 4.1.0~),
            dnsmasq-base
# First line of suggested packages will enable additional Incus storage backends
# Second line lists additional optional tools
Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
          incus-extra, lego, minio-client
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Breaks: ${runit:Breaks}
# The following line is a hack for an academic /usr-move problem (#1099444);
# Breaks+Replaces is the more Policy-compliant approach.
Conflicts: incus (<< 6.0.3-3~)
Description: Powerful system container and virtual machine manager - daemon (container-only)
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 It's image based with pre-made images available for a wide number of
 Linux distributions and is built around a very powerful, yet pretty
 simple, REST API.
 .
 This package contains only what is needed to run containers.

Package: incus-client
# The incus binary doesn't depend on liblxc1, so it can be built for any architecture
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: bash-completion,
          spice-client-gtk | virt-viewer
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Description: Powerful system container and virtual machine manager - client
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 A REST API is offered by Incus to remotely manage containers over the network,
 using an image based work-flow and with support for live migration.
 .
 This package contains the Incus command line client.

Package: incus-extra
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         rsync
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Breaks: incus-tools (<< 6.0.3-3~),
        incus-migrate (<< 6.0.3-3~)
Replaces: incus-tools (<< 6.0.3-3~),
          incus-migrate (<< 6.0.3-3~)
# lxd-tools also ships a `fuidshift` binary; we expect src:lxd to be RM'ed after the trixie release, so just use a simple Conflicts here
Conflicts: lxd-tools
Description: Powerful system container and virtual machine manager - extra tools
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 This package contains extra tools provided with Incus.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-incus - A tool to migrate LXC containers to Incus
  - lxd-to-incus - A tool to migrate LXD containers to Incus
  - incus-benchmark - A benchmarking tool for Incus
  - incus-migrate - A tool to turn any filesystem into an Incus instance
  - incus-simplestreams - Maintain an Incus-compatible simplestreams tree

Package: incus-agent
Architecture: linux-any
Depends: ${misc:Depends}
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Description: Incus guest agent

=== debian/watch ===
# For Debian packaging, only search for newer LTS releases, which have versions like <major>.0.<patch>
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/lxc/incus/tags .*/v(\d\.0\.\d)\.tar\.gz debian

## incus 6.0.5

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)
 SPHINXENV=doc/.sphinx/venv/bin/activate
 SPHINXPIPPATH=doc/.sphinx/venv/bin/pip
-OVN_MINVER=22.03.0
+OVN_MINVER=23.03.0
 OVS_MINVER=2.15.0
 
 ifneq "$(wildcard vendor)" ""
@@ -94,6 +94,7 @@
 	exit 1
 endif
 	$(GO) get -t -v -u ./...
+	$(GO) get github.com/go-jose/go-jose/v4@v4.0.5
 	$(GO) mod tidy --go=1.23.7
 	$(GO) get toolchain@none
 
@@ -296,13 +297,15 @@
 ifeq ($(shell command -v go-licenses),)
 	(cd / ; $(GO) install -v -x github.com/google/go-licenses@latest)
 endif
+ifeq ($(shell command -v govulncheck),)
+	go install golang.org/x/vuln/cmd/govulncheck@latest
+endif
 ifeq ($(shell command -v golangci-lint),)
 	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $$($(GO) env GOPATH)/bin
 endif
 ifeq ($(shell command -v shellcheck),)
 	echo "Please install shellcheck"
 	exit 1
-else
 endif
 ifeq ($(shell command -v flake8),)
 	echo "Please install flake8"
@@ -340,5 +343,3 @@
 .PHONY: update-openfga
 update-openfga:
 ifeq ($(shell command -v fga),)
-	(cd / ; $(GO) install -v -x github.com/openfga/cli/cmd/fga@latest)
-endif

=== debian/changelog ===
incus (6.0.5-3) unstable; urgency=medium

  * Cherry-pick upstream changes for libovsdb import path change

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 19 Oct 2025 23:28:28 +0000

incus (6.0.5-2) unstable; urgency=medium

  * Temporarily revert commit that broke running `incus exec` for VMs
    (Closes: #1114918)
  * Update IncusOS network struct patch
  * Drop redundant Rules-Requires-Root from d/control

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 27 Sep 2025 19:35:06 +0000

incus (6.0.5-1) unstable; urgency=medium

  * New upstream release:
    - Add patch to import IncusOS network struct definitions
    - Rebase d/p/002-adjust-import-paths.patch
    - Drop custom userns patch
    - Drop upstream cherry-picked commits
    - Update logic for building incus-agent binaries, including ones for
      Windows
  * d/control:
    - Update Build-Depends and Depends
    - Fix Breaks version
  * Update paths in d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 16 Aug 2025 01:49:46 +0000

incus (6.0.4-3) unstable; urgency=medium

  * Document packaging policy for LTS and Feature releases
  * Add patch for building with updated zitadel-oidc
  * d/control:
    - Limit VM dependencies to supported host architectures: amd64, arm64,
      ppc64el, and s390x
    - Update Build-Depends and Depends
    - Add Breaks for distrobuilder
    - Don't Suggest ceph-common for 32bit architectures
  * Update d/README.Debian

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 10 Aug 2025 15:56:48 +0000

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,16 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-any (>= 2:1.22~),
+               golang-any (>= 2:1.23~),
+               golang-github-adhocore-gronx-dev,
+               golang-github-apex-log-dev,
                golang-github-armon-go-proxyproto-dev,
                golang-github-cenkalti-backoff-dev,
                golang-github-checkpoint-restore-go-criu-dev (>= 7),
                golang-github-cowsql-go-cowsql-dev,
-               golang-github-digitalocean-go-qemu-dev,
                golang-github-digitalocean-go-smbios-dev,
                golang-github-dustinkirkland-golang-petname-dev,
-               golang-github-flosch-pongo2.v4-dev,
+               golang-github-flosch-pongo2.v6-dev,
                golang-github-fvbommel-sortorder-dev,
                golang-github-go-chi-chi-dev,
                golang-github-go-jose-go-jose-dev,
@@ -26,45 +27,43 @@
                golang-github-gorilla-mux-dev,
                golang-github-gorilla-websocket-dev,
                golang-github-gosexy-gettext-dev,
-               golang-github-j-keck-arping-dev,
+               golang-github-inconshreveable-mousetrap-dev,
                golang-github-jaypipes-pcidb-dev,
                golang-github-jochenvg-go-udev-dev,
                golang-github-kballard-go-shellquote-dev,
                golang-github-mattn-go-colorable-dev,
                golang-github-mattn-go-sqlite3-dev,
+               golang-github-mdlayher-arp-dev,
                golang-github-mdlayher-ndp-dev,
                golang-github-mdlayher-netx-dev,
                golang-github-mdlayher-vsock-dev,
                golang-github-miekg-dns-dev,
                golang-github-minio-minio-go-v7-dev,
                golang-github-mitchellh-mapstructure-dev,
-               golang-github-olekukonko-tablewriter-dev,
+               golang-github-olekukonko-tablewriter-dev (>= 1.0.9),
                golang-github-openfga-go-sdk-dev (>= 0.6.0),
+               golang-github-opensuse-umoci-dev,
                golang-github-osrg-gobgp-dev (>= 3.10.0),
-               golang-github-ovn-org-libovsdb-dev,
+               golang-github-ovn-kubernetes-libovsdb-dev,
                golang-github-pierrec-lz4-dev (>= 4.1.18),
                golang-github-pkg-sftp-dev,
                golang-github-pkg-xattr-dev,
-               golang-github-rican7-retry-dev,
-               golang-github-robfig-cron-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
                golang-github-stretchr-testify-dev,
                golang-github-vishvananda-netlink-dev,
-               golang-github-zitadel-oidc-dev (>= 3.0),
-               golang-gocapability-dev,
+               golang-github-zitadel-oidc-dev (>= 3.44.0),
                golang-golang-x-crypto-dev,
                golang-golang-x-exp-dev,
                golang-golang-x-oauth2-dev,
                golang-golang-x-sync-dev,
-               golang-golang-x-sys-dev,
+               golang-golang-x-sys-dev (>= 0.22.0-2~),
                golang-golang-x-term-dev,
                golang-golang-x-text-dev,
                golang-golang-x-tools-dev,
                golang-google-protobuf-dev,
                golang-gopkg-lxc-go-lxc.v2-dev,
-               golang-gopkg-tomb.v2-dev,
                golang-gopkg-yaml.v2-dev,
                golang-k8s-utils-dev,
                golang-starlark-dev (>= 0.0~git20240725.42030a7),
@@ -77,21 +76,21 @@
 Vcs-Browser: https://salsa.debian.org/go-team/packages/incus
 Vcs-Git: https://salsa.debian.org/go-team/packages/incus.git
 Homepage: https://linuxcontainers.org/incus/
-Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/lxc/incus
 
 Package: golang-github-lxc-incus-dev
 Architecture: all
 Multi-Arch: foreign
 Section: golang
-Depends: golang-github-armon-go-proxyproto-dev,
+Depends: golang-github-adhocore-gronx-dev,
+         golang-github-apex-log-dev,
+         golang-github-armon-go-proxyproto-dev,
          golang-github-cenkalti-backoff-dev,
          golang-github-checkpoint-restore-go-criu-dev (>= 7),
          golang-github-cowsql-go-cowsql-dev,
-         golang-github-digitalocean-go-qemu-dev,
          golang-github-digitalocean-go-smbios-dev,
          golang-github-dustinkirkland-golang-petname-dev,
-         golang-github-flosch-pongo2.v4-dev,
+         golang-github-flosch-pongo2.v6-dev,
          golang-github-fvbommel-sortorder-dev,
          golang-github-go-chi-chi-dev,
          golang-github-go-jose-go-jose-dev,
@@ -103,49 +102,48 @@
          golang-github-gorilla-mux-dev,
          golang-github-gorilla-websocket-dev,
          golang-github-gosexy-gettext-dev,
-         golang-github-j-keck-arping-dev,
+         golang-github-inconshreveable-mousetrap-dev,
          golang-github-jaypipes-pcidb-dev,
          golang-github-jochenvg-go-udev-dev,
          golang-github-kballard-go-shellquote-dev,
          golang-github-mattn-go-colorable-dev,
          golang-github-mattn-go-sqlite3-dev,
+         golang-github-mdlayher-arp-dev,
          golang-github-mdlayher-ndp-dev,
          golang-github-mdlayher-netx-dev,
          golang-github-mdlayher-vsock-dev,
          golang-github-miekg-dns-dev,
          golang-github-minio-minio-go-v7-dev,
          golang-github-mitchellh-mapstructure-dev,
-         golang-github-olekukonko-tablewriter-dev,
+         golang-github-olekukonko-tablewriter-dev (>= 1.0.9),
          golang-github-openfga-go-sdk-dev (>= 0.6.0),
+         golang-github-opensuse-umoci-dev,
          golang-github-osrg-gobgp-dev (>= 3.10.0),
-         golang-github-ovn-org-libovsdb-dev,
+         golang-github-ovn-kubernetes-libovsdb-dev,
          golang-github-pierrec-lz4-dev (>= 4.1.18),
          golang-github-pkg-sftp-dev,
          golang-github-pkg-xattr-dev,
-         golang-github-rican7-retry-dev,
-         golang-github-robfig-cron-dev,
          golang-github-sirupsen-logrus-dev,
          golang-github-spf13-cobra-dev,
          golang-github-spf13-pflag-dev,
          golang-github-stretchr-testify-dev,
          golang-github-vishvananda-netlink-dev,
-         golang-github-zitadel-oidc-dev (>= 3.0),
-         golang-gocapability-dev,
+         golang-github-zitadel-oidc-dev (>= 3.44.0),
          golang-golang-x-crypto-dev,
          golang-golang-x-exp-dev,
          golang-golang-x-oauth2-dev,
          golang-golang-x-sync-dev,
-         golang-golang-x-sys-dev,
+         golang-golang-x-sys-dev (>= 0.22.0-2~),
          golang-golang-x-term-dev,
          golang-golang-x-text-dev,
          golang-golang-x-tools-dev,
          golang-google-protobuf-dev,
          golang-gopkg-lxc-go-lxc.v2-dev,
-         golang-gopkg-tomb.v2-dev,
          golang-gopkg-yaml.v2-dev,
          golang-k8s-utils-dev,
          golang-starlark-dev (>= 0.0~git20240725.42030a7),
          ${misc:Depends}
+Breaks: distrobuilder (<< 3.2-3)
 Description: Powerful system container and virtual machine manager - library
  Incus is a next generation system container and virtual machine manager.
  It offers a unified user experience around full Linux systems running
@@ -157,19 +155,17 @@
 
 Package: incus
 # Technically this package is arch:all, but to use architecture restrictions for
-# the qemu-system-* dependencies, we must use a variant of arch:any
-Architecture: linux-any
-Depends: ${misc:Depends},
-         incus-agent (= ${binary:Version}),
+# supported host VM architectures, we must use a variant of arch:any
+Architecture: linux-any
+Depends: ${misc:Depends},
+         incus-agent (= ${binary:Version}) [amd64 arm64 ppc64el s390x],
          incus-base (= ${binary:Version}),
-         qemu-system-arm (>= 1:8.0) [arm64 armel armhf],
-         qemu-system-mips (>= 1:8.0) [mips64el],
+         qemu-system-arm (>= 1:8.0) [arm64],
          qemu-system-ppc (>= 1:8.0) [ppc64el],
-         qemu-system-riscv (>= 1:8.0) [riscv64],
          qemu-system-s390x (>= 1:8.0) [s390x],
-         qemu-system-x86 (>= 1:8.0) [amd64 i386],
-         swtpm,
-         virtiofsd [!armel !armhf !i386]
+         qemu-system-x86 (>= 1:8.0) [amd64],
+         swtpm [amd64 arm64 ppc64el s390x],
+         virtiofsd [amd64 arm64 ppc64el s390x]
 Suggests: gdisk
 Built-Using: ${misc:Built-Using}
 Static-Built-Using: ${misc:Static-Built-Using}
@@ -183,6 +179,7 @@
  simple, REST API.
  .
  This metapackage will install everything needed to run containers and VMs.
+ Only amd64, arm64, ppc64el, and s390x are supported as VM host architectures.
 
 Package: incus-base
 Architecture: linux-any
@@ -205,7 +202,7 @@
             dnsmasq-base
 # First line of suggested packages will enable additional Incus storage backends
 # Second line lists additional optional tools
-Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
+Suggests: btrfs-progs, ceph-common [!armel !armhf !i386], lvm2, zfsutils-linux,
           incus-extra, lego, minio-client
 Built-Using: ${misc:Built-Using}
 Static-Built-Using: ${misc:Static-Built-Using}
@@ -274,4 +271,3 @@
 Depends: ${misc:Depends}
 Built-Using: ${misc:Built-Using}
 Static-Built-Using: ${misc:Static-Built-Using}
-Description: Incus guest agent

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Don't build binaries we don't ship
# NOTE -- incus-agent is listed here, as it is compiled as a statically-linked binary below
export DH_GOLANG_EXCLUDES := deps dev_incus-client generate sysinfo test/mini-oidc test/tls2jwt incus-agent

# Include various test and other support files
export DH_GOLANG_INSTALL_EXTRA := test/ shared/subprocess/testscript/ internal/server/instance/drivers/agent-loader/ internal/server/metadata/configuration.json

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	# Build almost everything with dynamic linking
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_build

	# Build incus-agent as a statically-linked binary. For amd64 and arm64 builds, build a variety of versions including Windows binaries.
ifeq ($(DEB_HOST_ARCH),amd64)
	cd _build && GOARCH=386 CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.linux.i686 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build && GOARCH=amd64 CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.linux.x86_64 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build && GOARCH=386 GOOS=windows CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.windows.i686 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build && GOARCH=amd64 GOOS=windows CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.windows.x86_64 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build/bin && ln -s incus-agent.linux.x86_64 incus-agent
else ifeq ($(DEB_HOST_ARCH),arm64)
	cd _build && GOARCH=arm64 CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.linux.aarch64 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build && GOARCH=arm64 GOOS=windows CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent.windows.aarch64 -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
	cd _build/bin && ln -s incus-agent.linux.aarch64 incus-agent
else
	cd _build && CGO_ENABLED=0 GOPATH=$$(pwd) GOCACHE=$$(pwd)/go-build GO111MODULE=off GOPROXY=off GOTOOLCHAIN=local go build -trimpath -v -o bin/incus-agent -tags=agent,netgo github.com/lxc/incus/cmd/incus-agent
endif

	# Generate the man pages
	mkdir man1/
	TZ=UTC INCUS_CONF="_build/.config/incus" _build/bin/incus manpage man1/
	TZ=UTC INCUS_CONF="_build/.config/incus" _build/bin/incusd manpage man1/
	TZ=UTC help2man _build/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/fuidshift.1
	TZ=UTC HOME="~" help2man _build/bin/lxc-to-incus -n "Convert LXC containers to Incus" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxc-to-incus.1
	TZ=UTC help2man _build/bin/lxd-to-incus -n "Convert LXD containers to Incus" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-to-incus.1
	TZ=UTC help2man _build/bin/incus-agent -n "Incus virtual machine guest agent" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-agent.1
	TZ=UTC help2man _build/bin/incus-benchmark -n "Incus benchmark" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-benchmark.1
	TZ=UTC help2man _build/bin/incus-migrate -n "Incus physical to instance migration tool" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-migrate.1
	TZ=UTC help2man _build/bin/incus-simplestreams -n "Maintain an Incus-compatible simplestreams tree" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-simplestreams.1
	TZ=UTC help2man _build/bin/incus-user -n "Incus user project daemon" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-user.1

	# Generate shell completions
	mkdir completions/
	INCUS_CONF="_build/.config/incus" _build/bin/incus completion bash > completions/incus
	INCUS_CONF="_build/.config/incus" _build/bin/incus completion fish > completions/incus.fish
	INCUS_CONF="_build/.config/incus" _build/bin/incus completion zsh > completions/_incus

override_dh_auto_test:
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test

override_dh_auto_install:
	DH_GOLANG_EXCLUDES="" dh_auto_install

	# Don't package python script
	find ./debian -name import-busybox -delete

	# Need to rename various config files here, as dh_install cannot rename files
	install -Dpm 0644 debian/incus-base.dnsmasq debian/tmp/etc/dnsmasq.d-available/incus
	install -Dpm 0644 debian/incus-base.sysctl debian/tmp/etc/sysctl.d/10-incus-inotify.conf

override_dh_install:
	dh_install
	dh_installlogrotate --name incus
	dh_installsysusers --name incus

override_dh_installinit:
	dh_installinit --name incus --no-stop-on-upgrade --no-restart-after-upgrade
	dh_installinit --name incus-user --no-stop-on-upgrade --no-restart-after-upgrade --no-start
	dh_installinit --name incus-startup --no-stop-on-upgrade --no-restart-after-upgrade --no-start

override_dh_installsystemd:
	# Handle start / restart manually in incus.postinst
	dh_installsystemd --name incus-startup --no-stop-on-upgrade --no-restart-after-upgrade --no-start
	dh_installsystemd --name incus --no-stop-on-upgrade --no-restart-after-upgrade --no-start
	dh_installsystemd --name incus-user --no-stop-on-upgrade --no-restart-after-upgrade --no-start
	dh_installsystemd --name incus-agent --no-stop-on-upgrade --no-restart-after-upgrade --no-start
